Riickgabewerte von Kommandozeilenprogrammen vereinheitlichen
2004-07-26 00:00 - Jorg Riesmeier

Status: New Start date:
Target version:
Module: all Compiler:

Operating System:

Description

Momentan geben die meisten Programme nur 0 (ok) oder 1 (error) zurtick - wenn
Uberhaupt. Far die Skript-Programmierung wéare es aber nitzlich, wenn die
einzelnen Fehlerarten genauer unterschieden wiirden. Dies sollte Toolkit-weit
einheitlich passieren.

Vorschlag: Konstanten in einem Headerfile in ofstd/include
definieren, etwa RETCODE_SUCCESS, RETCODE_ERROR, ...

Das ganze sollte dann natdrlich auch in den "man pages" dokumentiert werden.
=== Nachtrag JR (2010-06-17) ===
Fir den Storage Commitment SCU habe ich momentan folgende "Exit Codes" vorgesehen:

/* exit codes for this command line tool */
/* (EXIT_SUCCESS and EXITCODE_FAILURE are system-dependent standard codes) */

#define EXITCODE_NO_ERROR 0
#define EXITCODE_COMMANDLINE_SYNTAX_ ERROR 1 // this code is the default for printError
0

#define EXITCODE_CANNOT_READ_INPUT_FILE 20
#define EXITCODE_NO_INPUT_FILES 21
#define EXITCODE_INVALID_INPUT_FILE 22
#define EXITCODE_NO_VALID_INPUT_FILES 23
#define EXITCODE_INVALID_OUTPUT_DIRECTORY 24
#define EXITCODE_CANNOT_WRITE_OUTPUT_FILE 40
#define EXITCODE_CANNOT_WRITE_REQUEST_FILE 41
#define EXITCODE_CANNOT_WRITE_RESPONSE_FILE 42

#define EXITCODE_CANNOT_WRITE_TRANSACTION_FILE 43

#define EXITCODE_CANNOT_INITIALIZE_ NETWORK 60
#define EXITCODE_CANNOT_NEGOTIATE_ASSOCIATION 61
#define EXITCODE_CANNOT_SEND_REQUEST 62
#define EXITCODE_CANNOT_WAIT FOR_RESPONSE 63

Es sollten zumindest die Exit Code-Gruppen 0-19, 20-39, 40-59, 60-79 usw. DCMTK-weit vereinheitlicht werden, damit der
Anwender weif3, ob ein allgemeiner, Datei-Eingabe-, Datei-Ausgabe- oder Netzwerk-Fehler aufgetreten ist.

Related issues:
Related to DCMTK - Feature #652: MoveSCU should return a non-zero return cod... Closed 2015-07-27

History

#1 - 2012-06-14 12:38 - Michael Onken

Ein Vorschlag ware wie oben angedeutet, die Gruppen "Input, Output, Networking, Processing" zu machen.

#2 - 2018-05-03 19:47 - Jorg Riesmeier
- Category set to Library and Apps
- % Done changed from 0 to 10

With commit a61a90c, common exit codes are now defined in "ofstd/include/ofexit.h".
